<template>
<v-layout align-center justify-center row wrap color="#f8f8f8" display: flex>
    <v-flex md12 pa-1 >
        <!-- search for desktop -->
        <v-layout >
            <v-flex md11 align-center>
                <div class="font-size-24-bold">Customer Management</div>
            </v-flex>
            <v-flex md1></v-flex>
            <v-flex md3 align-center py-3 v-if="!mobileView">
                <v-text-field color="#538795"
                    solo
                    light
                    label="search"
                    hide-details
                    v-model="searchAdmin"
                    append-icon="search"
                >
                </v-text-field>
            </v-flex>
        </v-layout>
        <!--  search for mobile -->
        <v-layout>
            <v-flex xs12 align-center py-3 v-if="mobileView">
                <v-text-field color="#538795"
                    solo
                    light
                    label="search"
                    hide-details
                    v-model="searchAdmin"
                    append-icon="search"
                >
                </v-text-field>
            </v-flex>
        </v-layout>
        <!-- table for desktop -->
    <div>
      <!-- <v-toolbar flat color="white"> -->
        <v-toolbar-title></v-toolbar-title>
        <!-- <v-divider
          class="mx-2"
          inset
          vertical
        ></v-divider> -->
        <v-spacer></v-spacer>
        <!-- edit dialog -->
        <v-dialog v-model="dialogEdit" max-width="400px">
          <v-card>
            <v-card-title>
              <v-icon style="margin-right:10px; color:#538795;">mdi-pencil</v-icon><span class="headline">Edit Customer</span>
            </v-card-title>
            <v-card-text>
              <v-container grid-list-md>
                <v-layout wrap>
                  <v-flex xs12 >
                    <v-text-field
                    ref="editNameEng"
                    v-model="editNameENG"
                    label="Name English"
                    color="#538795"
                    ></v-text-field>
                    <v-text-field
                    ref="editNameTH"
                    v-model="editNameTH"
                    label="Name Thai"
                    color="#538795"
                    ></v-text-field>
                    <v-text-field
                    ref="editMail"
                    v-model="editMail"
                    label="E-mail"
                    color="#538795"
                    ></v-text-field>
                     <!-- <v-text-field
                    ref="editLanguage"
                    v-model="editLanguage"
                    label="Language of E-mail"
                    color="#538795"
                    ></v-text-field> -->
                    <v-select
                      color="#538795"
                      v-model="editLanguage"
                      :items="langEmail"
                      menu-props="auto"
                      label="Select Language"
                      class="text-wrap"
                      ref="editLanguage"
                      dense
                      ></v-select>
                  </v-flex>
                </v-layout>
              </v-container>
            </v-card-text>
            <v-card-actions>
              <v-spacer></v-spacer>
              <v-btn color="red" flat @click="dialogEdit = false">Cancel</v-btn>
              <v-btn color="green darken-1" flat @click="edit">Save</v-btn>
            </v-card-actions>
          </v-card>
        </v-dialog>
        <!-- delete dialog -->
        <v-dialog v-model="dialogConfirm" max-width="400px">
          <v-card>
            <v-card-title>
              <v-icon style="margin-right:10px; color:#538795;">mdi-delete</v-icon><span class="headline">Delete Customer</span>
            </v-card-title>
            <v-card-text>
              <v-container grid-list-md>
                <v-layout wrap>
                    <v-flex xs12 style="background-color:#FEE3E3; color:red;">
                      <v-icon color="red">mdi-alert</v-icon>
                      You may be deleting user data. After you delete this, it can't be recovered.
                    </v-flex>
                </v-layout>
              </v-container>
            </v-card-text>
            <v-card-actions>
              <v-spacer></v-spacer>
              <v-btn color="black" flat @click="dialogConfirm = false">Cancel</v-btn>
              <v-btn color="red darken-1" class="white--text" @click="deleteItem">Delete</v-btn>
            </v-card-actions>
          </v-card>
        </v-dialog>
      <v-flex md12 pa-1>
        <v-data-table
            :headers="headers"
            :items="adminList"
            class="elevation-1"
            :search="searchAdmin"
            id="mytable"
        >
            <template v-slot:items="props">
            <td class="text-xs-center">{{ props.item.customer_id}}</td>
            <td class="text-xs-center">{{ props.item.taxid }}</td>
            <td class="text-xs-left">{{ props.item.name_eng }}</td>
            <td class="text-xs-left">{{ props.item.name_th }}</td>
            <td class="text-xs-left">{{ props.item.email }}</td>
            <td class="text-xs-center">{{ props.item.email_lang }}</td>
            <td class="justify-center layout px-0">
                <v-icon
                small
                color="#538795"
                class="mr-2"
                @click="editItem(props.item.id,props.item.email,props.item.name_eng,props.item.name_th,props.item.taxid,props.item.email_lang)"
                >
                edit
                </v-icon>
                <v-icon
                small
                color="red"
                @click="dialogDel(props.item.id)"
                >
                delete
                </v-icon>
            </td>
            </template>
        </v-data-table>
        <!-- <p>{{editedItem}}</p> -->
      </v-flex>
    </div>
    </v-flex>
</v-layout>
</template>
<script>
import moment from 'moment'
moment.locale('en')
export default {
  data () {
    return {
      dialog: false,
      dialogEdit: false,
      dialogConfirm: false,
      addMail: '',
      editMail: '',
      editNameTH: '',
      editNameENG:'',
      editLanguage: '',
      currentId: {},
      delelteId: '',
      role2: 'Admin',
      searchAdmin: '',
      adminList: [],
      //   mydropdown: ['Admin', 'Super Admin'],
      langEmail: [
        'EN','TH'
      ],
      headers: [
        { text: 'Customer Id', align: 'center', value: 'customer_id'},
        { text: 'Tax ID', align: 'left', value: 'taxid' },
        { text: 'Company Name (EN)', align: 'left', value: 'name_eng' },
        { text: 'Company Name (TH)', align: 'left', value: 'th' },
        { text: 'E-mail', align: 'left', value: 'email' },
        { text: 'Language of E-mail', align: 'center', value: 'email_lang' },
        { text: 'Action', align: 'center', value: 'action', sortable: false }
      ],
      editedItem: {
        email: '',
        role: ''
      },
      defaultItem: {
        email: '',
        role: 'admin'
      }
    }
  },
  methods: {
    clearForm () {
      Object.keys(this.form).forEach(f => {
        this.$refs[f].reset()
      })
    },
    async checkField () {
      this.formHasErrors = false
      Object.keys(this.form).forEach(f => {
        if (!this.form[f]) this.formHasErrors = true
        this.dialogloader = false
        this.$refs[f].validate(true)
      })
    },
    handleView () {
      this.mobileView = window.innerWidth <= 990
    },
    async getmybill () {
      try {
        this.istableloading = true
        var { data } = await this.axios.get(`${process.env.VUE_APP_APIHOST}/cust_list`, {
          headers: {
            Authorization: this.$cookies.get('token')
          }
        })
        this.adminList = data
        this.istableloading = false
      } catch (error) {
        this.istableloading = false
        console.log(error.message)
      }
    },
    editItem (item, email, nameENG, nameTH,taxid,emaillang) {
      this.currentId = { id: item, email: email, nameENG: nameENG, nameTH: nameTH,taxid:taxid,emaillang:emaillang }
      this.editMail = this.currentId.email
      this.editNameENG = this.currentId.nameENG
      this.editNameTH = this.currentId.nameTH
      this.editLanguage = this.currentId.emaillang
      // console.log(this.currentId)
      this.dialogEdit = true
      // console.log(this.currentId.id)
      // this.currentId.length = 0
    },
    async dialogDel (item) {
      this.delelteId = item
      this.dialogConfirm = true
      // console.log(this.delelteId)
    },
    async deleteItem () {
      this.istableloading = true
      // this.delelteId = item
      // confirm('Are you sure you want to delete this email?')
      // alert('Are you sure you want to delete this email?')
      let { data } = await this.axios.post(`${process.env.VUE_APP_APIHOST}/del_cust`,
        {
          id: this.delelteId
        }, {
          headers: { Authorization: this.$cookies.get('token') }
        })
      window.location.reload()
      //  && this.adminList.splice(index, 1)
    },
    close () {
      this.clearForm()
      this.dialog = false
      setTimeout(() => {
        this.editedItem = Object.assign({}, this.defaultItem)
        this.editedIndex = -1
      }, 300)
    },
    async edit () {
      this.istableloading = true
      // console.log('before', this.email, this.role2)
      let { data } = await this.axios.post(`${process.env.VUE_APP_APIHOST}/edit_cust`,
        {
          id: this.currentId.id,
          name_th: this.editNameTH,
          name_eng: this.editNameENG,
          email: this.editMail,
          emaillang: this.editLanguage,
          username: this.$cookies.get('username'),
          taxid: this.currentId.taxid,
        }, {
          headers: { Authorization: this.$cookies.get('token') }
        })
      alert('Edit Success!')
      window.location.reload()
    }
  },
  created () {
    this.getmybill()
    this.handleView()
    window.addEventListener('resize', this.handleView)
  },
  computed: {
    form () {
      return {
        addmail: this.addMail
      }
    }
  },
  watch: {
    dialog (val) {
      val || this.close()
    }
  }
}
</script>
